// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.





#include "parser.hxx"


// Unqualified %code blocks.
#line 123 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"


// Bison has some chunky destructors that trigger inlining warnings. Disable warning
// for this translation unit, since we can't really do much about the code it generates.
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Winline"

#include <vespa/document/bucket/bucketidfactory.h>
#include <vespa/document/repo/documenttyperepo.h>
#include <vespa/document/select/scanner.h>
#include <vespa/document/select/constant.h>
#include <vespa/document/select/branch.h>
#include <vespa/document/select/compare.h>
#include <vespa/document/select/doctype.h>
#include <vespa/document/select/valuenodes.h>
#include <vespa/document/util/stringutil.h>
#include <vespa/vespalib/util/exceptions.h>
#include <string>
#include <iostream>
#include <sstream>
#include <memory>

using string = vespalib::string;

// Wrap grabbing pointers from sub-rules in a way that nulls out the
// stored attribute from the Bison stack. Otherwise, exception cleanup
// in the parser code will attempt to double-delete the pointee.
// Yes, it's not beautiful, but that's life when you're dealing with raw pointers.
template <typename T>
std::unique_ptr<T> steal(T*& ptr) noexcept {
    std::unique_ptr<T> owned(ptr);
    ptr = nullptr;
    return owned;
}

// yylex tokenization must defer to scanner instance given to parser
#undef yylex
#define yylex scanner.yylex


#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 17 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
namespace document { namespace select {
#line 180 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"

  /// Build a parser object.
  DocSelParser::DocSelParser (DocSelScanner& scanner_yyarg, const BucketIdFactory& bucket_id_factory_yyarg, const DocumentTypeRepo& doc_type_repo_yyarg, std::unique_ptr<Node>& recv_expr_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      scanner (scanner_yyarg),
      bucket_id_factory (bucket_id_factory_yyarg),
      doc_type_repo (doc_type_repo_yyarg),
      recv_expr (recv_expr_yyarg)
  {}

  DocSelParser::~DocSelParser ()
  {}

  DocSelParser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  DocSelParser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  DocSelParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  DocSelParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (semantic_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}

  template <typename Base>
  DocSelParser::symbol_kind_type
  DocSelParser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  DocSelParser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  DocSelParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  DocSelParser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  DocSelParser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  DocSelParser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  DocSelParser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  DocSelParser::by_kind::clear ()
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  DocSelParser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  DocSelParser::symbol_kind_type
  DocSelParser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  DocSelParser::symbol_kind_type
  DocSelParser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  DocSelParser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  DocSelParser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  DocSelParser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  DocSelParser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  DocSelParser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  DocSelParser::symbol_kind_type
  DocSelParser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  DocSelParser::stack_symbol_type::stack_symbol_type ()
  {}

  DocSelParser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  DocSelParser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  DocSelParser::stack_symbol_type&
  DocSelParser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  DocSelParser::stack_symbol_type&
  DocSelParser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  DocSelParser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    switch (yysym.kind ())
    {
      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
#line 85 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 389 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_STRING: // STRING
#line 85 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 395 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_FP_MAP_LOOKUP: // FP_MAP_LOOKUP
#line 85 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 401 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_FP_ARRAY_LOOKUP: // FP_ARRAY_LOOKUP
#line 85 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 407 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_ID: // ID
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 413 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_USER: // USER
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 419 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_GROUP: // GROUP
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 425 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_SCHEME: // SCHEME
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 431 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_NAMESPACE: // NAMESPACE
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 437 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_SPECIFIC: // SPECIFIC
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 443 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_BUCKET: // BUCKET
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 449 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_GID: // GID
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 455 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_TYPE: // TYPE
#line 86 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 461 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_null_: // null_
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 467 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_bool_: // bool_
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 473 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_number: // number
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 479 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_string: // string
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 485 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_doc_type: // doc_type
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.abstract_node); }
#line 491 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_ident: // ident
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 497 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_id_arg: // id_arg
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 503 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_id_spec: // id_spec
#line 87 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 509 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_variable: // variable
#line 88 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 515 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_mangled_ident: // mangled_ident
#line 88 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.string_val); }
#line 521 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_field_spec: // field_spec
#line 88 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.field_expr_node); }
#line 527 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_value: // value
#line 88 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 533 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_arith_expr: // arith_expr
#line 88 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.value_node); }
#line 539 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_comparison: // comparison
#line 89 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.abstract_node); }
#line 545 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_leaf: // leaf
#line 89 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.abstract_node); }
#line 551 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_logical_expr: // logical_expr
#line 89 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.abstract_node); }
#line 557 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      case symbol_kind::S_expression: // expression
#line 89 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    { delete (yysym.value.abstract_node); }
#line 563 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
        break;

      default:
        break;
    }
  }

#if YYDEBUG
  template <typename Base>
  void
  DocSelParser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  DocSelParser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  DocSelParser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  DocSelParser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  DocSelParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  DocSelParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  DocSelParser::debug_level_type
  DocSelParser::debug_level () const
  {
    return yydebug_;
  }

  void
  DocSelParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  DocSelParser::state_type
  DocSelParser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  DocSelParser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  DocSelParser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  DocSelParser::operator() ()
  {
    return parse ();
  }

  int
  DocSelParser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // null_: NULL
#line 189 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
           { (yylhs.value.value_node) = new NullValueNode(); }
#line 834 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 3: // bool_: TRUE
#line 193 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
             { (yylhs.value.value_node) = new BoolValueNode(true); }
#line 840 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 4: // bool_: FALSE
#line 194 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
             { (yylhs.value.value_node) = new BoolValueNode(false); }
#line 846 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 5: // number: INTEGER
#line 198 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
              { (yylhs.value.value_node) = new IntegerValueNode((yystack_[0].value.i64_val), false); }
#line 852 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 6: // number: FLOAT
#line 199 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
              { (yylhs.value.value_node) = new FloatValueNode((yystack_[0].value.double_val)); }
#line 858 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 7: // string: STRING
#line 203 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
             { {
          try {
              (yylhs.value.value_node) = new StringValueNode(StringUtil::unescape(*steal<string>((yystack_[0].value.string_val))));
          } catch (const vespalib::IllegalArgumentException& exc) {
              throw syntax_error(yylhs.location, exc.getMessage());
          }
     } }
#line 870 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 8: // doc_type: ident
#line 213 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
            {
          if (doc_type_repo.getDocumentType(*(yystack_[0].value.string_val)) == nullptr) {
              throw syntax_error(yylhs.location, vespalib::make_string("Document type '%s' not found", (yystack_[0].value.string_val)->c_str()));
          }
          (yylhs.value.abstract_node) = new DocType(*steal<string>((yystack_[0].value.string_val)));
      }
#line 881 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 9: // ident: IDENTIFIER
#line 223 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 887 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 10: // ident: USER
#line 224 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 893 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 11: // ident: GROUP
#line 225 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 899 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 12: // ident: SCHEME
#line 226 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 905 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 13: // ident: TYPE
#line 227 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 911 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 14: // ident: NAMESPACE
#line 228 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 917 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 15: // ident: SPECIFIC
#line 229 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 923 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 16: // ident: BUCKET
#line 230 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 929 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 17: // ident: GID
#line 231 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 935 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 18: // id_arg: USER
#line 235 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 941 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 19: // id_arg: GROUP
#line 236 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 947 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 20: // id_arg: SCHEME
#line 237 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 953 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 21: // id_arg: NAMESPACE
#line 238 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 959 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 22: // id_arg: SPECIFIC
#line 239 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 965 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 23: // id_arg: BUCKET
#line 240 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 971 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 24: // id_arg: GID
#line 241 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 977 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 25: // id_arg: TYPE
#line 242 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 983 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 26: // id_spec: ID
#line 246 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                       {
          (void)steal<string>((yystack_[0].value.string_val)); // Explicitly discard.
          (yylhs.value.value_node) = new IdValueNode(bucket_id_factory, "id", ""); // Prefer shifting instead of reducing.
      }
#line 992 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 27: // id_spec: ID "." id_arg
#line 250 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                    {
          (void)steal<string>((yystack_[2].value.string_val)); // Explicitly discard.
          (yylhs.value.value_node) = new IdValueNode(bucket_id_factory, "id", *steal<string>((yystack_[0].value.string_val)));
      }
#line 1001 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 28: // id_spec: ID "." IDENTIFIER "(" ")"
#line 254 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                {
          (void)steal<string>((yystack_[4].value.string_val));  // Explicitly discard.
          (yylhs.value.value_node) = new FunctionValueNode(*steal<string>((yystack_[2].value.string_val)), std::make_unique<IdValueNode>(bucket_id_factory, "id", ""));
      }
#line 1010 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 29: // variable: "$" ident
#line 261 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                { (yylhs.value.value_node) = new VariableValueNode(*steal<string>((yystack_[0].value.string_val))); }
#line 1016 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 30: // mangled_ident: ident
#line 272 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1022 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 31: // mangled_ident: mangled_ident FP_MAP_LOOKUP
#line 273 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yystack_[1].value.string_val)->append(*steal<string>((yystack_[0].value.string_val))); (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 1028 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 32: // mangled_ident: mangled_ident FP_ARRAY_LOOKUP
#line 274 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yystack_[1].value.string_val)->append(*steal<string>((yystack_[0].value.string_val))); (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 1034 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 33: // mangled_ident: ID
#line 275 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1040 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 34: // field_spec: ident "." mangled_ident
#line 279 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                              {
          if (doc_type_repo.getDocumentType(*(yystack_[2].value.string_val)) == nullptr) {
              throw syntax_error(yylhs.location, vespalib::make_string("Document type '%s' not found", (yystack_[2].value.string_val)->c_str()));
          }
          (yylhs.value.field_expr_node) = new FieldExprNode(std::make_unique<FieldExprNode>(*steal<string>((yystack_[2].value.string_val))), *steal<string>((yystack_[0].value.string_val)));
      }
#line 1051 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 35: // field_spec: field_spec "." mangled_ident
#line 285 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                   { (yylhs.value.field_expr_node) = new FieldExprNode(steal<FieldExprNode>((yystack_[2].value.field_expr_node)), *steal<string>((yystack_[0].value.string_val))); }
#line 1057 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 36: // value: null_
#line 289 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1063 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 37: // value: bool_
#line 290 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1069 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 38: // value: string
#line 291 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1075 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 39: // value: id_spec
#line 292 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1081 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 40: // value: variable
#line 293 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1087 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 41: // value: NOW_FUNC
#line 294 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.value_node) = new CurrentTimeValueNode(); }
#line 1093 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 42: // arith_expr: value
#line 298 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1099 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 43: // arith_expr: number
#line 299 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1105 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 44: // arith_expr: "-" number
#line 301 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                            {
          if (dynamic_cast<IntegerValueNode*>((yystack_[0].value.value_node)) != nullptr) {
              (yylhs.value.value_node) = new IntegerValueNode(- static_cast<IntegerValueNode&>(*steal<ValueNode>((yystack_[0].value.value_node))).getValue(), false);
          } else {
              (yylhs.value.value_node) = new FloatValueNode(- dynamic_cast<FloatValueNode&>(*steal<ValueNode>((yystack_[0].value.value_node))).getValue());
          }
      }
#line 1117 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 45: // arith_expr: "+" number
#line 308 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1123 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 46: // arith_expr: field_spec
#line 309 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = steal<FieldExprNode>((yystack_[0].value.field_expr_node))->convert_to_field_value().release(); }
#line 1129 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 47: // arith_expr: field_spec "(" ")"
#line 310 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = steal<FieldExprNode>((yystack_[2].value.field_expr_node))->convert_to_function_call().release(); }
#line 1135 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 48: // arith_expr: arith_expr "+" arith_expr
#line 311 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "+", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1141 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 49: // arith_expr: arith_expr "-" arith_expr
#line 312 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "-", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1147 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 50: // arith_expr: arith_expr "*" arith_expr
#line 313 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "*", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1153 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 51: // arith_expr: arith_expr "/" arith_expr
#line 314 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "/", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1159 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 52: // arith_expr: arith_expr "%" arith_expr
#line 315 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "%", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1165 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 53: // arith_expr: "(" arith_expr ")"
#line 316 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                { (yylhs.value.value_node) = (yystack_[1].value.value_node); (yylhs.value.value_node)->setParentheses(); }
#line 1171 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 54: // arith_expr: arith_expr "." IDENTIFIER "(" ")"
#line 317 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                        { (yylhs.value.value_node) = new FunctionValueNode(*steal<string>((yystack_[2].value.string_val)), steal<ValueNode>((yystack_[4].value.value_node))); }
#line 1177 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 55: // comparison: arith_expr "==" arith_expr
#line 321 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::EQ, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1183 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 56: // comparison: arith_expr "!=" arith_expr
#line 322 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::NE, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1189 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 57: // comparison: arith_expr ">=" arith_expr
#line 323 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::GEQ, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1195 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 58: // comparison: arith_expr "<=" arith_expr
#line 324 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::LEQ, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1201 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 59: // comparison: arith_expr ">" arith_expr
#line 325 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::GT, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1207 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 60: // comparison: arith_expr "<" arith_expr
#line 326 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::LT, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1213 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 61: // comparison: arith_expr "=" arith_expr
#line 327 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), GlobOperator::GLOB, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1219 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 62: // comparison: arith_expr "=~" arith_expr
#line 328 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                  { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), RegexOperator::REGEX, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1225 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 63: // leaf: comparison
#line 332 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1231 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 64: // leaf: doc_type
#line 333 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1237 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 65: // leaf: arith_expr
#line 334 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                 { /* Actually bool_ or field_spec, see comment below..! */
          // Grammar-wise, we _do not_ accept arbitrary arith_exprs at this level. But the
          // selection grammar as it stands is otherwise ambiguous with LR(1) parsing.
          // More specifically, if we used field_spec instead of arith_expr here, the parser
          // state machine cannot decide what to do if it has processed the sequence '(' field_spec
          // and sees the next token of ')'. Since both logical_expr and arith_expr allows for
          // parenthesis expression recursion, the reduce step may produce either of these and
          // is therefore technically undefined. By using arith_expr instead for this rule, all
          // '(' field_spec ')' sequences result in an arith_expr rule match and the reduce/reduce
          // conflict goes away. We can then do a sneaky "run-time" type check to ensure we only
          // get the expected node from the rule.
          // It's not pretty, but it avoids an undefined grammar (which is much less pretty!).
          // The same goes for boolean constants, which may be used both as higher-level (non-value)
          // nodes or as value nodes to compare against.
          auto node = steal<ValueNode>((yystack_[0].value.value_node));
          if (auto* as_bool = dynamic_cast<BoolValueNode*>(node.get())) {
              (yylhs.value.abstract_node) = new Constant(as_bool->bool_value()); // Replace single bool node subtree with constant.
          } else {
              if (dynamic_cast<FieldValueNode*>(node.get()) == nullptr) {
                  throw syntax_error(yylhs.location, "expected field spec, doctype, bool or comparison");
              }
              // Implicit rewrite to non-null comparison node
              (yylhs.value.abstract_node) = new Compare(std::move(node),
                               FunctionOperator::NE,
                               std::make_unique<NullValueNode>(),
                               bucket_id_factory);
          }
      }
#line 1270 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 66: // logical_expr: leaf
#line 365 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1276 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 67: // logical_expr: logical_expr AND logical_expr
#line 366 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.abstract_node) = new And(steal<Node>((yystack_[2].value.abstract_node)), steal<Node>((yystack_[0].value.abstract_node))); }
#line 1282 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 68: // logical_expr: logical_expr OR logical_expr
#line 367 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.abstract_node) = new Or(steal<Node>((yystack_[2].value.abstract_node)), steal<Node>((yystack_[0].value.abstract_node))); }
#line 1288 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 69: // logical_expr: NOT logical_expr
#line 368 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.abstract_node) = new Not(steal<Node>((yystack_[0].value.abstract_node))); }
#line 1294 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 70: // logical_expr: "(" logical_expr ")"
#line 369 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                                    { (yylhs.value.abstract_node) = (yystack_[1].value.abstract_node); (yylhs.value.abstract_node)->setParentheses(); }
#line 1300 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 71: // expression: logical_expr
#line 373 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                   { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1306 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 72: // entry: expression "end of input"
#line 377 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                     { recv_expr = steal<Node>((yystack_[1].value.abstract_node)); }
#line 1312 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;

  case 73: // entry: "end of input"
#line 378 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
                     { recv_expr = std::make_unique<Constant>(true); }
#line 1318 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"
    break;


#line 1322 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  DocSelParser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  DocSelParser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  DocSelParser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // DocSelParser::context.
  DocSelParser::context::context (const DocSelParser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  DocSelParser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  DocSelParser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  DocSelParser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char DocSelParser::yypact_ninf_ = -28;

  const signed char DocSelParser::yytable_ninf_ = -1;

  const short
  DocSelParser::yypact_[] =
  {
      62,   -28,   -28,   -28,   -28,   102,   -28,   185,   102,   -27,
     -27,   -28,   -28,   -28,   -28,   -16,   -28,   -28,   -28,   -28,
     -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,    -1,
     -28,   -28,   -12,   -28,   176,   -28,   -28,    52,    11,    15,
     -28,   -28,    10,     6,   -28,   -28,   200,   170,   170,     7,
     142,   142,   142,   142,   142,   142,   142,   142,     2,   142,
     142,   142,   142,   142,   102,   102,   -28,   -28,   -28,   -28,
      21,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,
     -28,   -28,    33,    33,   -28,   142,    -1,   129,   129,   129,
     129,   129,   129,   129,   129,    30,    13,    13,   -17,   -17,
      53,   -28,    65,    54,   -28,   -28,    90,    55,   -28,   -28
  };

  const signed char
  DocSelParser::yydefact_[] =
  {
       0,    73,     2,     3,     4,     0,    41,     0,     0,     0,
       0,     9,     7,     6,     5,    26,    10,    11,    12,    14,
      15,    16,    17,    13,    36,    37,    43,    38,    64,     8,
      39,    40,    46,    42,    65,    63,    66,    71,     0,     0,
      69,    29,    65,     0,    45,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,     1,    53,    70,
       0,    18,    19,    20,    21,    22,    23,    24,    25,    27,
      33,    30,    34,    35,    47,     0,     0,    61,    62,    55,
      56,    57,    58,    59,    60,     0,    48,    49,    50,    51,
      52,    67,    68,     0,    31,    32,     0,     0,    28,    54
  };

  const signed char
  DocSelParser::yypgoto_[] =
  {
     -28,   -28,   -28,    59,   -28,   -28,     9,   -28,   -28,   -28,
      35,   -28,   -28,    -8,   -28,   -28,    -4,   -28,   -28
  };

  const signed char
  DocSelParser::yydefgoto_[] =
  {
      -1,    24,    25,    26,    27,    28,    86,    79,    30,    31,
      82,    32,    33,    34,    35,    36,    37,    38,    39
  };

  const signed char
  DocSelParser::yytable_[] =
  {
      42,    40,    58,    46,    43,    13,    14,    48,    49,    29,
      63,    66,    64,    65,    29,    67,    41,    29,    47,    50,
      51,    52,    53,    54,    55,    56,    57,    69,    84,    58,
      95,    68,    58,    59,    60,    61,    62,    63,    61,    62,
      63,   103,    87,    88,    89,    90,    91,    92,    93,    94,
     107,    96,    97,    98,    99,   100,    81,    81,    64,    65,
     101,   102,     1,   104,   105,     2,     3,     4,    44,    45,
       5,    64,    58,    29,    29,   108,   109,   106,     0,     6,
       7,     0,     8,    83,     0,     9,    10,     0,     0,     0,
      11,    12,     0,     0,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,     2,     3,     4,     0,    58,
       5,    68,     0,    59,    60,    61,    62,    63,     0,     6,
       7,     0,     8,     0,     0,     9,    10,     0,     0,     0,
      11,    12,     0,     0,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,     2,     3,     4,    58,     0,
       0,     0,    59,    60,    61,    62,    63,     0,     0,     6,
       7,     0,    85,     0,     0,     9,    10,     0,     0,     0,
      11,    12,     0,     0,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    50,    51,    52,    53,    54,
      55,    56,    57,     0,     0,    58,     0,     0,    11,    59,
      60,    61,    62,    63,    80,    16,    17,    18,    19,    20,
      21,    22,    23,    11,     0,     0,     0,     0,     0,     0,
      16,    17,    18,    19,    20,    21,    22,    23,    70,     0,
       0,     0,     0,     0,     0,    71,    72,    73,    74,    75,
      76,    77,    78
  };

  const signed char
  DocSelParser::yycheck_[] =
  {
       8,     5,    19,    19,     8,    32,    33,    19,    20,     0,
      27,     0,     6,     7,     5,     0,     7,     8,    19,     9,
      10,    11,    12,    13,    14,    15,    16,    21,    21,    19,
      28,    21,    19,    23,    24,    25,    26,    27,    25,    26,
      27,    20,    50,    51,    52,    53,    54,    55,    56,    57,
      20,    59,    60,    61,    62,    63,    47,    48,     6,     7,
      64,    65,     0,    30,    31,     3,     4,     5,     9,    10,
       8,     6,    19,    64,    65,    21,    21,    85,    -1,    17,
      18,    -1,    20,    48,    -1,    23,    24,    -1,    -1,    -1,
      28,    29,    -1,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,     3,     4,     5,    -1,    19,
       8,    21,    -1,    23,    24,    25,    26,    27,    -1,    17,
      18,    -1,    20,    -1,    -1,    23,    24,    -1,    -1,    -1,
      28,    29,    -1,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,     3,     4,     5,    19,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    -1,    -1,    17,
      18,    -1,    20,    -1,    -1,    23,    24,    -1,    -1,    -1,
      28,    29,    -1,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    19,    -1,    -1,    28,    23,
      24,    25,    26,    27,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,    39,    40,    41,    42,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    36,    37,    38,    39,
      40,    41,    42
  };

  const signed char
  DocSelParser::yystos_[] =
  {
       0,     0,     3,     4,     5,     8,    17,    18,    20,    23,
      24,    28,    29,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    47,    48,    49,    50,    51,    52,
      54,    55,    57,    58,    59,    60,    61,    62,    63,    64,
      62,    52,    59,    62,    49,    49,    19,    19,    19,    20,
       9,    10,    11,    12,    13,    14,    15,    16,    19,    23,
      24,    25,    26,    27,     6,     7,     0,     0,    21,    21,
      28,    35,    36,    37,    38,    39,    40,    41,    42,    53,
      34,    52,    56,    56,    21,    20,    52,    59,    59,    59,
      59,    59,    59,    59,    59,    28,    59,    59,    59,    59,
      59,    62,    62,    20,    30,    31,    59,    20,    21,    21
  };

  const signed char
  DocSelParser::yyr1_[] =
  {
       0,    46,    47,    48,    48,    49,    49,    50,    51,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    53,    53,
      53,    53,    53,    53,    53,    53,    54,    54,    54,    55,
      56,    56,    56,    56,    57,    57,    58,    58,    58,    58,
      58,    58,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    60,    60,    60,    60,    60,
      60,    60,    60,    61,    61,    61,    62,    62,    62,    62,
      62,    63,    64,    64
  };

  const signed char
  DocSelParser::yyr2_[] =
  {
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     5,     2,
       1,     2,     2,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     3,     3,     2,
       3,     1,     2,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const DocSelParser::yytname_[] =
  {
  "\"end of input\"", "error", "\"invalid token\"", "NULL", "TRUE",
  "FALSE", "AND", "OR", "NOT", "\"=\"", "\"=~\"", "\"==\"", "\"!=\"",
  "\">=\"", "\"<=\"", "\">\"", "\"<\"", "NOW_FUNC", "\"$\"", "\".\"",
  "\"(\"", "\")\"", "\",\"", "\"+\"", "\"-\"", "\"*\"", "\"/\"", "\"%\"",
  "IDENTIFIER", "STRING", "FP_MAP_LOOKUP", "FP_ARRAY_LOOKUP", "FLOAT",
  "INTEGER", "ID", "USER", "GROUP", "SCHEME", "NAMESPACE", "SPECIFIC",
  "BUCKET", "GID", "TYPE", "NEG", "UNOT", "NON_DOT", "$accept", "null_",
  "bool_", "number", "string", "doc_type", "ident", "id_arg", "id_spec",
  "variable", "mangled_ident", "field_spec", "value", "arith_expr",
  "comparison", "leaf", "logical_expr", "expression", "entry", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  DocSelParser::yyrline_[] =
  {
       0,   189,   189,   193,   194,   198,   199,   203,   213,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   235,   236,
     237,   238,   239,   240,   241,   242,   246,   250,   254,   261,
     272,   273,   274,   275,   279,   285,   289,   290,   291,   292,
     293,   294,   298,   299,   301,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   321,   322,   323,   324,   325,
     326,   327,   328,   332,   333,   334,   365,   366,   367,   368,
     369,   373,   377,   378
  };

  void
  DocSelParser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  DocSelParser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  DocSelParser::symbol_kind_type
  DocSelParser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
    };
    // Last valid token kind.
    const int code_max = 300;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 17 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"
} } // document::select
#line 1939 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/parser.cxx"

#line 381 "/builddir/build/BUILD/vespa-8.360.19/document/src/vespa/document/select/grammar/parser.yy"


void document::select::DocSelParser::error(const location_type& l, const std::string& what) {
    throw syntax_error(l, what);
}

void throw_parser_syntax_error(const document::select::DocSelParser::location_type& loc, const std::string& msg) {
    throw document::select::DocSelParser::syntax_error(loc, msg);
}

#pragma GCC diagnostic pop
